/******************************************************************************
 *
 *	Papillon
 *	ver 1.0.1
 *	2008. 2-
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include "defrsc.h"

//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/



/************************************************
 *	XN[̏
 ***********************************************/
void
init_screen( void )
{
  UInt16 error;
  UInt32 rom_ver;
  UInt32 width = 160, height = 160, depth = 2;


  // ݂̐F[x擾
  WinScreenMode( winScreenModeGet,
                 &Screen.save.width,
                 &Screen.save.height,
                 &Screen.save.depth,
                 NULL );

  // 160*160 2bit ݒ
  WinScreenMode( winScreenModeSet, &width, &height, &depth, NULL );

  // obNXN[쐬
  Screen.back_h = WinCreateOffscreenWindow( BACK_WIDTH, BACK_HEIGHT+BACK_BTM_BLANK,
                                            screenFormat, &error );
  ErrFatalDisplayIf( error, "Error Creating Offscreen" );

  // OS3.5O
  FtrGet( sysFtrCreator, sysFtrNumROMVersion, &rom_ver );
  if( rom_ver < PalmRomVer350 ) Screen.old = true;

  // XN[̃|C^擾
  if( Screen.old )
    {
      Screen.back_p = (void *) Screen.back_h -> displayAddrV20;
      Screen.lcd_p = (void  *) WinGetDisplayWindow() -> displayAddrV20;
    }
  else
    {
      Screen.back_p = (void *) BmpGetBits( WinGetBitmap( Screen.back_h ) );
      Screen.lcd_p = (void  *) BmpGetBits( WinGetBitmap( WinGetDisplayWindow() ) );
    }

  // XN[NA
  clear_screen();
}



/************************************************
 *	obNXN[LCDɃRs[
 ***********************************************/
void
copy_buff_to_lcd( void )
{
  int i;
  UInt32 *screen = (UInt32 *) Screen.lcd_p;
  UInt32 *back = (UInt32 *) Screen.back_p + (48*16 /4) + 1;


  for( i = 0; i < 160; i++)
    {
      *screen++ = *back++;	// 1 40Bytes 160dot
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      *screen++ = *back++;
      back += 2;		// ] 8Bytes E16dot
    }
}



/************************************************
 *	SʃNA
 ***********************************************/
void
clear_screen( void )
{
  int i;
  UInt32 *screen = (UInt32 *) Screen.back_p;


  for( i = 0; i < 192*12; i++ )
    {
      *screen++ = 0L;
    }
}



/************************************************
 *	BG`
 ***********************************************/
void
draw_bg( void )
{
  int i;
  UInt32 *screen = (UInt32 *) Screen.back_p + (16 * 48/4) + 1;
  UInt32 *bg;


  if( Screen.old )
    bg = Bg.handle -> displayAddrV20;
  else
    bg = BmpGetBits( WinGetBitmap( Bg.handle ) );

  for( i = 0; i < BG_HEIGHT; i++ )
    {
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      *screen++ = *bg++;
      screen += 2;
    }
}



/************************************************
 *	XvCg\iobNXN[j
 *	16*nhbg 2bit XvCg
 ***********************************************/
void
sprite( Coord x, Coord y, WinHandle chr_no )
{
  int i, step, max;
  UInt16 *chr;
  UInt32 shift;
  UInt32 *mask = (UInt8 *) Screen.back_p + y * 48 + (x / 8) * 2;
  UInt32 *or;
  RectangleType r;


  // ͈̓`FbN
  if( (UInt16) x >= 160+BACK_W_BLANK || (UInt16) y >= 160+BACK_H_BLANK )
    return;

  if( Screen.old )
    chr = chr_no ->displayAddrV20;
  else
    chr = BmpGetBits( WinGetBitmap( chr_no ) );

  // TCY擾
  MemMove( &r, &(chr_no ->windowBounds), sizeof( RectangleType ) );

  max = r.extent.y;
  step = 16 - ( ( x & 7 ) *2 );

  for( i = 0; i < max; i++ )
    {
      shift = (UInt32) *chr << step;	// 8dot * 2 and
      *mask &= ~shift;

      or = mask;
      mask = (UInt16 *) mask + 1;
      chr++;

      shift =  (UInt32) *chr << step;
      *mask &= ~shift;
      chr++;

      shift = (UInt32) *chr << step;	// 8dot * 2 or
      *or |= shift;

      or = (UInt16 *) or + 1;
      chr++;

      shift = (UInt32) *chr << step;
      *or |= shift;

      mask = (UInt16 *) mask + 23;
      chr++;
    }
}



/************************************************
 *	PSETiobNXN[j
 ***********************************************/
void
pset( Coord x, Coord y, PsetColorType color, PsetWidthType size )
{
  UInt32 mask = 0xffff3fff;
  int ms, cs;
  UInt16 *screen = (UInt8 *) Screen.back_p + y * 48 + (x / 8) * 2;

  // ͈̓`FbN
  if( (UInt16) x >= 160+BACK_W_BLANK || (UInt16) y >= 160+BACK_H_BLANK )
    return;

  ms = ( x & 7 ) * 2;
  cs = ( 7- (x & 7) ) * 2;

  *screen &= mask >> ms;
  *screen |= color << cs;

  if( size == bold )
    {
      *(screen+24) &= mask >> ms;
      *(screen+24) |= color << cs;

      pset( x-1, y, color, nomal );
    }
}



#if 0
/************************************************
 *	POINTiobNXN[j
 ***********************************************/
Boolean
point( Coord x, Coord y, PsetColorType color )
{
  UInt16 *screen = (UInt16 *) Screen.back_p + y * 48 + (x / 8) * 2;
  UInt16 pix;
  UInt16 col = (UInt16) color;

  // ͈̓`FbN
  if( (UInt16) x >= 160+BACK_W_BLANK || (UInt16) y >= 160+BACK_H_BLANK )
    return false;

  col <<= (7- (x & 7 )) *2;
  pix = ( (UInt16) *screen & col ) - col;

  return ( pix ? false : true );
}
#endif



/************************************************
 *	LINEiobNXN[j
 * http://www2.starcat.ne.jp/~fussy/algo/
 * 
 ***********************************************/
void
line( Coord x0, Coord y0, Coord x1, Coord y1, PsetColorType col, PsetWidthType size )
{
  int i, e, max;
  int dx = ( x1 > x0 ) ? x1 - x0 : x0 - x1;
  int dy = ( y1 > y0 ) ? y1 - y0 : y0 - y1;
  int sx = ( x1 > x0 ) ? 1 : -1;
  int sy = ( y1 > y0 ) ? 1 : -1;


  if( dx >= dy )
    {
      e = -dx;
      max = (dx + 1) / 2;
      for( i = 0; i < max; i++ )
        {
          pset( x0, y0, col, size );
          pset( x1, y1, col, size );

          x0 += sx;
          x1 -= sx;
          e += 2 * dy;
          if( e >= 0 )
            {
              y0 += sy;
              y1 -= sy;
              e -= 2 * dx;
            }
        }
      if( ((dx + 1) % 2) != 0 )
        {
          pset( x0, y0, col, size );
        }
    }
  else
    {
      e = -dy;
      max = ( dy + 1 ) / 2;
      for( i = 0; i < max; i++ )
        {
          pset( x0, y0, col, size );
          pset( x1, y1, col, size );

          y0 += sy;
          y1 -= sy;
          e += 2 * dx;
          if( e >= 0 )
            {
              x0 += sx;
              x1 -= sx;
              e -= 2 * dy;
            }
        }
      if( ((dy + 1) % 2) != 0 )
        {
          pset( x0, y0, col, size );
        }
    }
}



