/******************************************************************************
 *
 *	Papillon
 *	color edition
 *	ver 1.1.0
 *	2008.04
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include "defrsc.h"

//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/
void show_ready( void );
void show_over( void );
void show_clear( void  );
void show_pause( void );
void show_title( void );
Boolean input_anykey( void );
void clear_sound( void );
void over_sound( void );



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/



/************************************************
 *	Q[Cxg
 ***********************************************/
Boolean
select_game_event( void )
{
  Boolean result = false;
  UInt32 key, keyf;


  // bZ[WEFCg
  if( Message.wait )
    {
      Message.wait--;
      return true;
    }

  // |[Y
  if( Game.pause && Game.state == GAME_START )
    {
      show_pause();
      return true;
    }

  switch( Game.state )
    {
    case GAME_TITLE:
      demo();

      if( Game.catch || Key.keep & (KEY_1|KEY_2|KEY_3|KEY_4) )
        {
          Game.state = GAME_START;
          init_game_status();
          Message.wait = DEMO_WAIT;
          set_se( hit );
        }
      result = true;
      break;

    case GAME_READY:
      result = true;
      break;

    case GAME_CLEAR:
      clear_sound();
      show_clear();

      if( input_anykey() )
        {
          Game.state = GAME_START;
          level_up();
          clear_screen();
        }
      result = true;
      break;

    case GAME_OVER:
      over_sound();
      show_over();

      if( input_anykey() )
        {
          Game.state = GAME_TITLE;
          key = Key.single, keyf = Key.keep;

          // nCXRAXV
          check_hiscore( Player.score );
          clear_screen();

          init_demo();
          Key.single = key, Key.keep = keyf;
        }
      result = true;
      break;
    }

  return result;
}



/************************************************
 *	^Cg\
 ***********************************************/
void
show_title( void )
{
  RectangleType r;
  ChrHandleType chr = title_mask;


  r.topLeft.x = 0; r.topLeft.y = 0; r.extent.x = 117; r.extent.y = 33;
  WinCopyRectangle( Bmp.handle[ chr ],
                    Screen.back_h,
                    &r,
                    4+BACK_W_BLANK,
                    4+BACK_H_BLANK,
                    winMask );

  chr = title;
  WinCopyRectangle( Bmp.handle[ chr ],
                    Screen.back_h,
                    &r,
                    4+BACK_W_BLANK,
                    4+BACK_H_BLANK,
                    winOverlay );
}



/************************************************
 *	Xe[^Xʕ\
 ***********************************************/
void
show_status( void )
{
  ChrHandleType chr = lv;

  //Lv
  sprite( 2+BACK_W_BLANK, 2+BACK_H_BLANK, Bmp.handle[ chr ] );
  show_num( 18+BACK_W_BLANK, 2+BACK_H_BLANK, Lv.level, 2 );

  // Score
  show_num( 40+BACK_W_BLANK, 2+BACK_H_BLANK, Player.score, 7 );
}



/************************************************
 *	ʉACR\
 ***********************************************/
void
show_se_icon( void )
{
  ChrHandleType chr = se_off;


  sprite( 160-14+BACK_W_BLANK,
          2+BACK_H_BLANK,
          Bmp.handle[ chr + Sound.on ] );
}



///////////////////////////////////////////////////////////////////////////////

/************************************************
 *	͑҂
 ***********************************************/
static Boolean
input_anykey( void )
{
  if( Key.keep & ( KEY_1 | KEY_2 | KEY_3 | KEY_4 )
      || Pen.down )
    {
      Pen.down = false;
      set_se( click );

      return true;
    }

  return false;
}



/************************************************
 *	xNA\
 ***********************************************/
static void
show_clear( void )
{
  RectangleType r;
  ChrHandleType chr = clear_mask;


  r.topLeft.x = 0; r.topLeft.y = 0; r.extent.x = 93; r.extent.y = 14;
  WinCopyRectangle( Bmp.handle[ chr ],
                    Screen.back_h,
                    &r,
                    53+BACK_W_BLANK,
                    73+BACK_H_BLANK,
                    winMask );

  chr = clear;
  WinCopyRectangle( Bmp.handle[ chr ],
                    Screen.back_h,
                    &r,
                    53+BACK_W_BLANK,
                    73+BACK_H_BLANK,
                    winOverlay );
}



/************************************************
 *	Q[I[o[\
 ***********************************************/
static void
show_over( void )
{
  RectangleType r;
  ChrHandleType chr = over_mask;


  r.topLeft.x = 0; r.topLeft.y = 0; r.extent.x = 78; r.extent.y = 14;
  WinCopyRectangle( Bmp.handle[ chr ],
                    Screen.back_h,
                    &r,
                    41+BACK_W_BLANK,
                    73+BACK_H_BLANK,
                    winMask );

  chr = game_over;
  WinCopyRectangle( Bmp.handle[ chr ],
                    Screen.back_h,
                    &r,
                    41+BACK_W_BLANK,
                    73+BACK_H_BLANK,
                    winOverlay );
}



/************************************************
 *	|[Y\
 ***********************************************/
static void
show_pause( void )
{
  RectangleType r;
  ChrHandleType chr = pause_mask;


  r.topLeft.x = 0; r.topLeft.y = 0; r.extent.x = 46; r.extent.y = 14;
  WinCopyRectangle( Bmp.handle[ chr ],
                    Screen.back_h,
                    &r,
                    57+BACK_W_BLANK,
                    73+BACK_H_BLANK,
                    winMask );

  chr = pause;
  WinCopyRectangle( Bmp.handle[ chr ],
                    Screen.back_h,
                    &r,
                    57+BACK_W_BLANK,
                    73+BACK_H_BLANK,
                    winOverlay );
}



/************************************************
 *	NA^Q[I[o[ ʉ
 ***********************************************/
static void
clear_sound( void )
{
  if( Message.se )
    {
      set_se( g_clear );
      Message.se = false;
    }
}


static void
over_sound( void )
{
  if( Message.se )
    {
      set_se( g_over );
      Message.se = false;
    }
}


